Index: perlconfig.c
===================================================================
--- perlconfig.c	(revision c1d2e6c253c25bace704f5d9d9171396524ae595)
+++ perlconfig.c	(revision e8c6d8f81a793b9ebcbd5898fa4b2ebd2b7c1c51)
@@ -44,6 +44,6 @@
   h = newHV();
 
-#define MSG2H(h,field) hv_store(h, #field, strlen(#field), \
-			      newSVpv(owl_message_get_##field(m),0), 0)
+#define MSG2H(h,field) (void)hv_store(h, #field, strlen(#field),        \
+                                      newSVpv(owl_message_get_##field(m),0), 0)
 
   if (owl_message_is_type_zephyr(m)
@@ -59,8 +59,8 @@
       owl_free(ptr);
     }
-    hv_store(h, "fields", strlen("fields"), newRV_noinc((SV*)av_zfields), 0);
-
-    hv_store(h, "auth", strlen("auth"), 
-	     newSVpv(owl_zephyr_get_authstr(owl_message_get_notice(m)),0),0);
+    (void)hv_store(h, "fields", strlen("fields"), newRV_noinc((SV*)av_zfields), 0);
+
+    (void)hv_store(h, "auth", strlen("auth"), 
+                   newSVpv(owl_zephyr_get_authstr(owl_message_get_notice(m)),0),0);
   }
 
@@ -68,6 +68,6 @@
   for(i=0; i<j; i++) {
     pair=owl_list_get_element(&(m->attributes), i);
-    hv_store(h, owl_pair_get_key(pair), strlen(owl_pair_get_key(pair)),
-	     newSVpv(owl_pair_get_value(pair),0),0);
+    (void)hv_store(h, owl_pair_get_key(pair), strlen(owl_pair_get_key(pair)),
+                   newSVpv(owl_pair_get_value(pair),0),0);
   }
   
@@ -88,11 +88,11 @@
     MSG2H(h, header); 
   }
-  hv_store(h, "time", strlen("time"), newSVpv(owl_message_get_timestr(m),0),0);
-  hv_store(h, "id", strlen("id"), newSViv(owl_message_get_id(m)),0);
-  hv_store(h, "deleted", strlen("deleted"), newSViv(owl_message_is_delete(m)),0);
-  hv_store(h, "private", strlen("private"), newSViv(owl_message_is_private(m)),0);
-  hv_store(h, "should_wordwrap",
-	   strlen("should_wordwrap"), newSViv(
-					      owl_filter_message_match(wrap, m)),0);
+  (void)hv_store(h, "time", strlen("time"), newSVpv(owl_message_get_timestr(m),0),0);
+  (void)hv_store(h, "id", strlen("id"), newSViv(owl_message_get_id(m)),0);
+  (void)hv_store(h, "deleted", strlen("deleted"), newSViv(owl_message_is_delete(m)),0);
+  (void)hv_store(h, "private", strlen("private"), newSViv(owl_message_is_private(m)),0);
+  (void)hv_store(h, "should_wordwrap",
+                 strlen("should_wordwrap"), newSViv(
+                                                    owl_filter_message_match(wrap, m)),0);
 
   type = owl_message_get_type(m);
@@ -102,5 +102,5 @@
   blessas = owl_sprintf("BarnOwl::Message::%s", type);
 
-  hr = sv_2mortal(newRV_noinc((SV*)h));
+  hr = newRV_noinc((SV*)h);
   stash =  gv_stashpv(blessas,0);
   if(!stash) {
@@ -182,7 +182,6 @@
   dSP ;
   int count;
-  unsigned int len;
   SV *msgref, *srv;
-  char *out, *preout;
+  char *out;
   
   ENTER ;
@@ -191,5 +190,5 @@
   PUSHMARK(SP) ;
   msgref = owl_perlconfig_message2hashref(m);
-  XPUSHs(msgref);
+  XPUSHs(sv_2mortal(msgref));
   PUTBACK ;
   
@@ -199,6 +198,5 @@
 
   if (SvTRUE(ERRSV)) {
-    STRLEN n_a;
-    owl_function_error("Perl Error: '%s'", SvPV(ERRSV, n_a));
+    owl_function_error("Perl Error: '%s'", SvPV_nolen(ERRSV));
     /* and clear the error */
     sv_setsv (ERRSV, &PL_sv_undef);
@@ -213,8 +211,5 @@
 
   if (srv) {
-    preout=SvPV(srv, len);
-    out = owl_malloc(strlen(preout)+1);
-    strncpy(out, preout, len);
-    out[len] = '\0';
+    out = owl_strdup(SvPV_nolen(srv));
   } else {
     out = NULL;
@@ -235,7 +230,7 @@
 {
   dSP;
-  unsigned int count, len, i;
+  unsigned int count, i;
   SV *msgref, *srv;
-  char *out, *preout;
+  char *out;
 
   msgref = owl_perlconfig_message2hashref(m);
@@ -245,5 +240,5 @@
 
   PUSHMARK(SP);
-  XPUSHs(msgref);
+  XPUSHs(sv_2mortal(msgref));
   for(i=0;i<argc;i++) {
     XPUSHs(sv_2mortal(newSVpv(argv[i], 0)));
@@ -261,6 +256,5 @@
 
   if (SvTRUE(ERRSV)) {
-    STRLEN n_a;
-    owl_function_error("Error: '%s'", SvPV(ERRSV, n_a));
+    owl_function_error("Error: '%s'", SvPV_nolen(ERRSV));
     /* and clear the error */
     sv_setsv (ERRSV, &PL_sv_undef);
@@ -270,8 +264,5 @@
 
   if (srv) {
-    preout=SvPV(srv, len);
-    out = owl_malloc(strlen(preout)+1);
-    strncpy(out, preout, len);
-    out[len] = '\0';
+    out = owl_strdup(SvPV_nolen(srv));
   } else {
     out = NULL;
@@ -301,9 +292,7 @@
   owl_global_set_no_have_config(&g);
 
-
   ret=perl_parse(p, owl_perl_xs_init, 2, args, NULL);
   if (ret || SvTRUE(ERRSV)) {
-    STRLEN n_a;
-    err=owl_strdup(SvPV(ERRSV, n_a));
+    err=owl_strdup(SvPV_nolen(ERRSV));
     sv_setsv(ERRSV, &PL_sv_undef);     /* and clear the error */
     return(err);
@@ -312,6 +301,5 @@
   ret=perl_run(p);
   if (ret || SvTRUE(ERRSV)) {
-    STRLEN n_a;
-    err=owl_strdup(SvPV(ERRSV, n_a));
+    err=owl_strdup(SvPV_nolen(ERRSV));
     sv_setsv(ERRSV, &PL_sv_undef);     /* and clear the error */
     return(err);
@@ -321,16 +309,16 @@
 
   /* create legacy variables */
-  perl_get_sv("BarnOwl::id", TRUE);
-  perl_get_sv("BarnOwl::class", TRUE);
-  perl_get_sv("BarnOwl::instance", TRUE);
-  perl_get_sv("BarnOwl::recipient", TRUE);
-  perl_get_sv("BarnOwl::sender", TRUE);
-  perl_get_sv("BarnOwl::realm", TRUE);
-  perl_get_sv("BarnOwl::opcode", TRUE);
-  perl_get_sv("BarnOwl::zsig", TRUE);
-  perl_get_sv("BarnOwl::msg", TRUE);
-  perl_get_sv("BarnOwl::time", TRUE);
-  perl_get_sv("BarnOwl::host", TRUE);
-  perl_get_av("BarnOwl::fields", TRUE);
+  get_sv("BarnOwl::id", TRUE);
+  get_sv("BarnOwl::class", TRUE);
+  get_sv("BarnOwl::instance", TRUE);
+  get_sv("BarnOwl::recipient", TRUE);
+  get_sv("BarnOwl::sender", TRUE);
+  get_sv("BarnOwl::realm", TRUE);
+  get_sv("BarnOwl::opcode", TRUE);
+  get_sv("BarnOwl::zsig", TRUE);
+  get_sv("BarnOwl::msg", TRUE);
+  get_sv("BarnOwl::time", TRUE);
+  get_sv("BarnOwl::host", TRUE);
+  get_av("BarnOwl::fields", TRUE);
 
   if(file) {
@@ -339,9 +327,8 @@
   }
 
-  perl_eval_pv(owl_perlwrap_codebuff, FALSE);
+  eval_pv(owl_perlwrap_codebuff, FALSE);
 
   if (SvTRUE(ERRSV)) {
-    STRLEN n_a;
-    err=owl_strdup(SvPV(ERRSV, n_a));
+    err=owl_strdup(SvPV_nolen(ERRSV));
     sv_setsv (ERRSV, &PL_sv_undef);     /* and clear the error */
     return(err);
@@ -358,27 +345,6 @@
 /* returns whether or not a function exists */
 int owl_perlconfig_is_function(char *fn) {
-  if (perl_get_cv(fn, FALSE)) return(1);
+  if (get_cv(fn, FALSE)) return(1);
   else return(0);
-}
-
-/* returns 0 on success */
-int owl_perlconfig_get_hashkeys(char *hashname, owl_list *l)
-{
-  HV *hv;
-  HE *he;
-  char *key;
-  I32 i;
-
-  if (owl_list_create(l)) return(-1);
-  hv = get_hv(hashname, FALSE);
-  if (!hv) return(-1);
-  i = hv_iterinit(hv);
-  while ((he = hv_iternext(hv))) {
-    key = hv_iterkey(he, &i);
-    if (key) {
-      owl_list_append_element(l, owl_strdup(key));
-    }
-  }
-  return(0);
 }
 
@@ -392,21 +358,21 @@
   if (!owl_global_have_config(&g)) return NULL;
 
+  ENTER;
+  SAVETMPS;
   /* execute the subroutine */
-  response = perl_eval_pv(line, FALSE);
+  response = eval_pv(line, FALSE);
 
   if (SvTRUE(ERRSV)) {
-    STRLEN n_a;
-    owl_function_error("Perl Error: '%s'", SvPV(ERRSV, n_a));
+    owl_function_error("Perl Error: '%s'", SvPV_nolen(ERRSV));
     sv_setsv (ERRSV, &PL_sv_undef);     /* and clear the error */
   }
 
   preout=SvPV(response, len);
-  /* leave enough space in case we have to add a newline */
-  out = owl_malloc(strlen(preout)+2);
-  strncpy(out, preout, len);
-  out[len] = '\0';
-  if (!strlen(out) || out[strlen(out)-1]!='\n') {
-    strcat(out, "\n");
-  }
+  if (len == 0 || preout[len - 1] != '\n')
+    out = owl_sprintf("%s\n", preout);
+  else
+    out = owl_strdup(preout);
+  FREETMPS;
+  LEAVE;
 
   return(out);
@@ -439,5 +405,4 @@
   char * ret = NULL;
   SV *rv;
-  STRLEN n_a;
   dSP;
 
@@ -458,5 +423,5 @@
 
   if(SvTRUE(ERRSV)) {
-    owl_function_error("%s", SvPV(ERRSV, n_a));
+    owl_function_error("%s", SvPV_nolen(ERRSV));
     (void)POPs;
   } else {
@@ -465,5 +430,5 @@
     rv = POPs;
     if(SvTRUE(rv)) {
-      ret = owl_strdup(SvPV(rv, n_a));
+      ret = owl_strdup(SvPV_nolen(rv));
     }
   }
@@ -482,5 +447,6 @@
 void owl_perlconfig_dispatch_free(owl_dispatch *d)
 {
-  SvREFCNT_dec(d->pfunc);
+  SvREFCNT_dec(d->data);
+  owl_free(d);
 }
 
@@ -489,5 +455,4 @@
   SV *cb = (SV*)(e->cbdata);
   SV *text;
-  unsigned int n_a;
   dSP;
 
@@ -508,5 +473,5 @@
 
   if(SvTRUE(ERRSV)) {
-    owl_function_error("%s", SvPV(ERRSV, n_a));
+    owl_function_error("%s", SvPV_nolen(ERRSV));
   }
 
@@ -526,17 +491,16 @@
   call_pv("BarnOwl::Hooks::_mainloop_hook", G_DISCARD|G_EVAL);
   if(SvTRUE(ERRSV)) {
-    STRLEN n_a;
-    owl_function_error("%s", SvPV(ERRSV, n_a));
+    owl_function_error("%s", SvPV_nolen(ERRSV));
   }
   return;
 }
 
-void owl_perlconfig_do_dispatch(owl_dispatch *d)
-{
-  SV *cb = d->pfunc;
-  unsigned int n_a;
+void owl_perlconfig_dispatch(owl_dispatch *d)
+{
+  SV *cb = d->data;
   dSP;
   if(cb == NULL) {
     owl_function_error("Perl callback is NULL!");
+    return;
   }
 
@@ -550,5 +514,5 @@
 
   if(SvTRUE(ERRSV)) {
-    owl_function_error("%s", SvPV(ERRSV, n_a));
+    owl_function_error("%s", SvPV_nolen(ERRSV));
   }
 
@@ -556,2 +520,39 @@
   LEAVE;
 }
+
+void owl_perlconfig_perl_timer(owl_timer *t, void *data)
+{
+  SV *obj = data;
+
+  if(!SvROK(obj)) {
+    return;
+  }
+
+  dSP;
+  ENTER;
+  SAVETMPS;
+
+  PUSHMARK(SP);
+  XPUSHs(obj);
+  PUTBACK;
+
+  call_method("do_callback", G_DISCARD|G_KEEPERR|G_EVAL);
+
+  SPAGAIN;
+
+  if (SvTRUE(ERRSV)) {
+    owl_function_error("Error in calback: '%s'", SvPV_nolen(ERRSV));
+    sv_setsv (ERRSV, &PL_sv_undef);
+  }
+
+  PUTBACK;
+  FREETMPS;
+  LEAVE;
+}
+
+void owl_perlconfig_perl_timer_destroy(owl_timer *t)
+{
+  if(SvOK((SV*)t->data)) {
+    SvREFCNT_dec((SV*)t->data);
+  }
+}
Index: perlglue.xs
===================================================================
--- perlglue.xs	(revision 740d5f76770d93df8236a59996511e8ce2d1c0c5)
+++ perlglue.xs	(revision 16318254b6ef4667cccff7ba22cf480c35e23b0c)
@@ -24,8 +24,8 @@
 	 * complex argument processing or something, we define a
 	 * simple version here that takes arguments in as flat a
-	 * manner as possible, to simplify the XS code, with a name
-	 * with a trailing `_internal', and write a perl wrapper in
-	 * perlwrap.pm that munges the arguments as appropriate and
-	 * calls the internal version.
+	 * manner as possible, to simplify the XS code, put it in
+	 * BarnOwl::Intenal::, and write a perl wrapper in perlwrap.pm
+	 * that munges the arguments as appropriate and calls the
+	 * internal version.
 	 */
 
@@ -62,5 +62,7 @@
 getcurmsg()
 	CODE:
-		ST(0) = owl_perlconfig_curmessage2hashref();
+		RETVAL = owl_perlconfig_curmessage2hashref();
+	OUTPUT:
+		RETVAL
 
 int
@@ -141,6 +143,193 @@
 		if (rv) owl_free(rv);
 
-void
-new_command_internal(name, func, summary, usage, description)
+void queue_message(msg) 
+	SV *msg
+	PREINIT:
+		owl_message *m;
+	CODE:
+	{
+		if(!SvROK(msg) || SvTYPE(SvRV(msg)) != SVt_PVHV) {
+			croak("Usage: BarnOwl::queue_message($message)");
+		}
+
+		m = owl_perlconfig_hashref2message(msg);
+
+		owl_global_messagequeue_addmsg(&g, m);
+	}
+
+void admin_message(header, body) 
+	char *header
+	char *body
+	CODE:
+	{
+		owl_function_adminmsg(header, body);		
+	}
+
+void start_question(line, callback)
+	char *line
+	SV *callback
+	PREINIT:
+	CODE:
+	{
+		if(!SV_IS_CODEREF(callback))
+			croak("Callback must be a subref");
+
+		owl_function_start_question(line);
+
+		SvREFCNT_inc(callback);
+		owl_editwin_set_cbdata(owl_global_get_typwin(&g), callback);
+		owl_editwin_set_callback(owl_global_get_typwin(&g), owl_perlconfig_edit_callback);
+	}
+
+void start_password(line, callback)
+	char *line
+	SV *callback
+	PREINIT:
+	CODE:
+	{
+		if(!SV_IS_CODEREF(callback))
+			croak("Callback must be a subref");
+
+		owl_function_start_password(line);
+
+		SvREFCNT_inc(callback);
+		owl_editwin_set_cbdata(owl_global_get_typwin(&g), callback);
+		owl_editwin_set_callback(owl_global_get_typwin(&g), owl_perlconfig_edit_callback);
+	}
+
+void start_edit_win(line, callback)
+	char *line
+	SV *callback
+	PREINIT:
+		owl_editwin * e;
+		char buff[1024];
+	CODE:
+	{
+		if(!SV_IS_CODEREF(callback))
+			croak("Callback must be a subref");
+
+		e = owl_global_get_typwin(&g);
+		owl_editwin_new_style(e, OWL_EDITWIN_STYLE_MULTILINE,
+				      owl_global_get_msg_history(&g));
+		owl_editwin_clear(e);
+		owl_editwin_set_dotsend(e);
+		snprintf(buff, 1023, "----> %s\n", line);
+		owl_editwin_set_locktext(e, buff);
+
+		owl_global_set_typwin_active(&g);
+
+		SvREFCNT_inc(callback);
+		owl_editwin_set_cbdata(owl_global_get_typwin(&g), callback);
+		owl_editwin_set_callback(owl_global_get_typwin(&g), owl_perlconfig_edit_callback);
+	}
+
+
+char * 
+get_data_dir ()
+	CODE:
+		RETVAL = (char *) owl_get_datadir();
+	OUTPUT:
+	RETVAL
+
+char * 
+get_config_dir ()
+	CODE:
+		RETVAL = (char *) owl_global_get_confdir(&g);
+	OUTPUT:
+	RETVAL	
+
+void
+popless_text(text) 
+	char *text
+	CODE:
+	{
+		owl_function_popless_text(text);
+	}
+
+void
+popless_ztext(text) 
+	char *text
+	CODE:
+	{
+		owl_fmtext fm;
+		owl_fmtext_init_null(&fm);
+		owl_fmtext_append_ztext(&fm, text);
+		owl_function_popless_fmtext(&fm);
+		owl_fmtext_free(&fm);
+	}
+
+void
+error(text) 
+	char *text
+	CODE:
+	{
+		owl_function_error("%s", text);
+	}
+
+void
+create_style(name, object)
+     char *name
+     SV  *object
+     PREINIT:
+		owl_style *s;
+     CODE:
+	{
+		s = owl_malloc(sizeof(owl_style));
+		owl_style_create_perl(s, name, object);
+		owl_global_add_style(&g, s);
+	}
+
+int
+getnumcolors()
+	CODE:
+		RETVAL = owl_function_get_color_count();
+	OUTPUT:
+		RETVAL
+
+void
+_remove_filter(filterName)
+	char *filterName
+	CODE:
+	{
+		/* Don't delete the current view, or the 'all' filter */
+		if (strcmp(filterName, owl_view_get_filtname(owl_global_get_current_view(&g)))
+		    && strcmp(filterName, "all")) {
+			owl_global_remove_filter(&g,filterName);
+		}
+	}
+
+char *
+wordwrap(in, cols)
+	char *in
+	int cols
+	PREINIT:
+		char *rv = NULL;
+	CODE:
+		rv = owl_text_wordwrap(in, cols);
+		RETVAL = rv;	
+	OUTPUT:
+		RETVAL
+	CLEANUP:
+		if (rv) owl_free(rv);
+
+void
+add_dispatch(fd, cb)
+	int fd
+	SV * cb
+	CODE:
+        SvREFCNT_inc(cb);
+	owl_select_add_perl_dispatch(fd, cb);
+
+void
+remove_dispatch(fd)
+	int fd
+	CODE:
+	owl_select_remove_perl_dispatch(fd);
+
+MODULE = BarnOwl		PACKAGE = BarnOwl::Internal
+
+
+void
+new_command(name, func, summary, usage, description)
 	char *name
 	SV *func
@@ -172,176 +361,6 @@
 	   }
 
-void queue_message(msg) 
-	SV *msg
-	PREINIT:
-		owl_message *m;
-	CODE:
-	{
-		if(!SvROK(msg) || SvTYPE(SvRV(msg)) != SVt_PVHV) {
-			croak("Usage: BarnOwl::queue_message($message)");
-		}
-
-		m = owl_perlconfig_hashref2message(msg);
-
-		owl_global_messagequeue_addmsg(&g, m);
-	}
-
-void admin_message(header, body) 
-	char *header
-	char *body
-	CODE:
-	{
-		owl_function_adminmsg(header, body);		
-	}
-
-void start_question(line, callback)
-	char *line
-	SV *callback
-	PREINIT:
-	CODE:
-	{
-		if(!SV_IS_CODEREF(callback))
-			croak("Callback must be a subref");
-
-		owl_function_start_question(line);
-
-		SvREFCNT_inc(callback);
-		owl_editwin_set_cbdata(owl_global_get_typwin(&g), callback);
-		owl_editwin_set_callback(owl_global_get_typwin(&g), owl_perlconfig_edit_callback);
-	}
-
-void start_password(line, callback)
-	char *line
-	SV *callback
-	PREINIT:
-	CODE:
-	{
-		if(!SV_IS_CODEREF(callback))
-			croak("Callback must be a subref");
-
-		owl_function_start_password(line);
-
-		SvREFCNT_inc(callback);
-		owl_editwin_set_cbdata(owl_global_get_typwin(&g), callback);
-		owl_editwin_set_callback(owl_global_get_typwin(&g), owl_perlconfig_edit_callback);
-	}
-
-void start_edit_win(line, callback)
-	char *line
-	SV *callback
-	PREINIT:
-		owl_editwin * e;
-		char buff[1024];
-	CODE:
-	{
-		if(!SV_IS_CODEREF(callback))
-			croak("Callback must be a subref");
-
-		e = owl_global_get_typwin(&g);
-		owl_editwin_new_style(e, OWL_EDITWIN_STYLE_MULTILINE,
-				      owl_global_get_msg_history(&g));
-		owl_editwin_clear(e);
-		owl_editwin_set_dotsend(e);
-		snprintf(buff, 1023, "----> %s\n", line);
-		owl_editwin_set_locktext(e, buff);
-
-		owl_global_set_typwin_active(&g);
-
-		SvREFCNT_inc(callback);
-		owl_editwin_set_cbdata(owl_global_get_typwin(&g), callback);
-		owl_editwin_set_callback(owl_global_get_typwin(&g), owl_perlconfig_edit_callback);
-	}
-
-
-char * 
-get_data_dir ()
-	CODE:
-		RETVAL = (char *) owl_get_datadir();
-	OUTPUT:
-	RETVAL
-
-char * 
-get_config_dir ()
-	CODE:
-		RETVAL = (char *) owl_global_get_confdir(&g);
-	OUTPUT:
-	RETVAL	
-
-void
-popless_text(text) 
-	char *text
-	CODE:
-	{
-		owl_function_popless_text(text);
-	}
-
-void
-popless_ztext(text) 
-	char *text
-	CODE:
-	{
-		owl_fmtext fm;
-		owl_fmtext_init_null(&fm);
-		owl_fmtext_append_ztext(&fm, text);
-		owl_function_popless_fmtext(&fm);
-		owl_fmtext_free(&fm);
-	}
-
-void
-error(text) 
-	char *text
-	CODE:
-	{
-		owl_function_error("%s", text);
-	}
-
-void
-create_style(name, object)
-     char *name
-     SV  *object
-     PREINIT:
-		owl_style *s;
-     CODE:
-	{
-		s = owl_malloc(sizeof(owl_style));
-		owl_style_create_perl(s, name, object);
-		owl_global_add_style(&g, s);
-	}
-
-int
-getnumcolors()
-	CODE:
-		RETVAL = owl_function_get_color_count();
-	OUTPUT:
-		RETVAL
-
-void
-_remove_filter(filterName)
-	char *filterName
-	CODE:
-	{
-		/* Don't delete the current view, or the 'all' filter */
-		if (strcmp(filterName, owl_view_get_filtname(owl_global_get_current_view(&g)))
-		    && strcmp(filterName, "all")) {
-			owl_global_remove_filter(&g,filterName);
-		}
-	}
-
-char *
-wordwrap(in, cols)
-	char *in
-	int cols
-	PREINIT:
-		char *rv = NULL;
-	CODE:
-		rv = owl_text_wordwrap(in, cols);
-		RETVAL = rv;	
-	OUTPUT:
-		RETVAL
-	CLEANUP:
-		if (rv) owl_free(rv);
-
-void
-new_variable_string_internal(name, ival, summ, desc)
+void
+new_variable_string(name, ival, summ, desc)
 	char * name
 	char * ival
@@ -356,5 +375,5 @@
 
 void
-new_variable_int_internal(name, ival, summ, desc)
+new_variable_int(name, ival, summ, desc)
 	char * name
 	int ival
@@ -369,5 +388,5 @@
 
 void
-new_variable_bool_internal(name, ival, summ, desc)
+new_variable_bool(name, ival, summ, desc)
 	char * name
 	int ival
@@ -381,15 +400,31 @@
 				      ival);
 
-void
-add_dispatch(fd, cb)
-	int fd
-	SV * cb
-	CODE:
-        SvREFCNT_inc(cb);
-	owl_select_add_perl_dispatch(fd, cb);
-
-void
-remove_dispatch(fd)
-	int fd
-	CODE:
-	owl_select_remove_perl_dispatch(fd);
+IV
+add_timer(after, interval, cb)
+	int after
+	int interval
+	SV *cb
+	PREINIT:
+		SV *ref;
+		owl_timer *t;
+	CODE:
+		ref = sv_rvweaken(newSVsv(cb));
+		t = owl_select_add_timer(after,
+					 interval,
+					 owl_perlconfig_perl_timer,
+					 owl_perlconfig_perl_timer_destroy,
+					 ref);
+	owl_function_debugmsg("Created timer %p", t);
+	RETVAL = (IV)t;
+	OUTPUT:
+		RETVAL
+
+void
+remove_timer(timer)
+	IV timer
+	PREINIT:
+		owl_timer *t;
+	CODE:
+		t = (owl_timer*)timer;
+		owl_function_debugmsg("Freeing timer %p", t);
+				owl_select_remove_timer(t);
Index: perlwrap.pm
===================================================================
--- perlwrap.pm	(revision 740d5f76770d93df8236a59996511e8ce2d1c0c5)
+++ perlwrap.pm	(revision e9708d2252864359eae00b0d49981f5659a555f5)
@@ -242,5 +242,5 @@
     );
 
-    BarnOwl::new_command_internal($name, $func, $args{summary}, $args{usage}, $args{description});
+    BarnOwl::Internal::new_command($name, $func, $args{summary}, $args{usage}, $args{description});
 }
 
@@ -275,15 +275,15 @@
 
 sub new_variable_int {
-    unshift @_, \&BarnOwl::new_variable_int_internal, 0;
+    unshift @_, \&BarnOwl::Internal::new_variable_int, 0;
     goto \&_new_variable;
 }
 
 sub new_variable_bool {
-    unshift @_, \&BarnOwl::new_variable_bool_internal, 0;
+    unshift @_, \&BarnOwl::Internal::new_variable_bool, 0;
     goto \&_new_variable;
 }
 
 sub new_variable_string {
-    unshift @_, \&BarnOwl::new_variable_string_internal, "";
+    unshift @_, \&BarnOwl::Internal::new_variable_string, "";
     goto \&_new_variable;
 }
@@ -795,6 +795,11 @@
 =item $receiveMessage
 
-Called with a C<BarnOwl::Message> object every time BarnOwl appends a
-new message to its message list
+Called with a C<BarnOwl::Message> object every time BarnOwl receives a
+new incoming message.
+
+=item $newMessage
+
+Called with a C<BarnOwl::Message> object every time BarnOwl appends
+I<any> new message to the message list.
 
 =item $mainLoop
@@ -810,4 +815,12 @@
 displayed in a popup window, with zephyr formatting parsed.
 
+=item $getQuickstart
+
+Called by :show quickstart to display 2-5 lines of help on how to
+start using the protocol. The result from every function registered
+with this hook will be appended and displayed in an admin message,
+with zephyr formatting parsed. The format should be
+"@b(Protocol:)\nSome text.\nMore text.\n"
+
 =back
 
@@ -818,5 +831,6 @@
 our @EXPORT_OK = qw($startup $shutdown
                     $receiveMessage $newMessage
-                    $mainLoop $getBuddyList);
+                    $mainLoop $getBuddyList
+                    $getQuickstart);
 
 our %EXPORT_TAGS = (all => [@EXPORT_OK]);
@@ -828,4 +842,5 @@
 our $mainLoop = BarnOwl::Hook->new;
 our $getBuddyList = BarnOwl::Hook->new;
+our $getQuickstart = BarnOwl::Hook->new;
 
 # Internal startup/shutdown routines called by the C code
@@ -921,4 +936,8 @@
 }
 
+sub _get_quickstart {
+    return join("\n", $getQuickstart->run);
+}
+
 ################################################################################
 # Built-in perl styles
@@ -1214,4 +1233,35 @@
 }
 
+package BarnOwl::Timer;
+
+sub new {
+    my $class = shift;
+    my $args = shift;
+
+    my $cb = $args->{cb};
+    die("Invalid callback pased to BarnOwl::Timer\n") unless ref($cb) eq 'CODE';
+
+    my $self = {cb => $cb};
+
+    bless($self, $class);
+
+    $self->{timer} = BarnOwl::Internal::add_timer($args->{after} || 0,
+                                                  $args->{interval} || 0,
+                                                  $self);
+    return $self;
+}
+
+sub do_callback {
+    my $self = shift;
+    $self->{cb}->($self);
+}
+
+sub DESTROY {
+    my $self = shift;
+    if(defined($self->{timer})) {
+        BarnOwl::Internal::remove_timer($self->{timer});
+    }
+}
+
 
 # switch to package main when we're done
Index: popexec.c
===================================================================
--- popexec.c	(revision 1971b59613b1999b306139b8c2119beeb060b84c)
+++ popexec.c	(revision 40c665796431e6bd112feb7e36e6520b696396c4)
@@ -51,13 +51,13 @@
     return NULL;
   } else if (pid != 0) {
+    close(child_write_fd);
     /* still in owl */
-    int muxhandle;
     pe->pid=pid;
     pe->winactive=1;
-    pe->rfd = parent_read_fd;
-    close(child_write_fd);
-    muxhandle = owl_muxevents_add(owl_global_get_muxevents(&g),
-    				  parent_read_fd, OWL_MUX_READ|OWL_MUX_EXCEPT,
-    				  owl_popexec_inputhandler, (void*)pe);
+    pe->dispatch.fd = parent_read_fd;
+    pe->dispatch.cfunc = owl_popexec_inputhandler;
+    pe->dispatch.destroy = owl_popexec_free_dispatch;
+    pe->dispatch.data = pe;
+    owl_select_add_dispatch(&pe->dispatch);
     pe->refcount++;
   } else {
@@ -73,9 +73,4 @@
     dup2(child_write_fd, 2 /*stderr*/);
     close(child_write_fd);
-    
-    while(0) {
-      write(child_write_fd, "meep\n", 5);
-      sleep(1);
-    }
 
     argv[0] = "sh";
@@ -90,7 +85,7 @@
 }
 
-void owl_popexec_inputhandler(int handle, int fd, int eventmask, void *data)
+void owl_popexec_inputhandler(owl_dispatch *d)
 {
-  owl_popexec *pe = (owl_popexec*)data;
+  owl_popexec *pe = d->data;
   int navail, bread, rv_navail;
   char *buf;
@@ -101,5 +96,5 @@
   /* If pe->winactive is 0 then the vwin has closed. 
    * If pe->pid is 0 then the child has already been reaped.
-   * if pe->rfd is -1 then the fd has been closed out.
+   * if d->fd is -1 then the fd has been closed out.
    * Under these cases we want to get to a state where:
    *   - data read until end if child running
@@ -110,12 +105,10 @@
 
   /* the viewwin has closed */
-  if (pe->rfd<0 && !pe->pid && !pe->winactive) {
-    owl_muxevents_remove(owl_global_get_muxevents(&g), handle);
-    owl_function_debugmsg("unref of %p from input handler at A", pe);
-    owl_popexec_unref(pe);
+  if (!pe->pid && !pe->winactive) {
+    owl_select_remove_dispatch(d->fd);
     return;
   }
 
-  if (0 != (rv_navail = ioctl(fd, FIONREAD, (void*)&navail))) {
+  if (0 != (rv_navail = ioctl(d->fd, FIONREAD, (void*)&navail))) {
     owl_function_debugmsg("ioctl error");
   }
@@ -130,15 +123,9 @@
       owl_viewwin_redisplay(pe->vwin, 1);
     }
-    if (pe->rfd>0) {
-      close(pe->rfd);
-      pe->rfd = -1;
-    }
-    owl_muxevents_remove(owl_global_get_muxevents(&g), handle);
-    owl_function_debugmsg("unref of %p from input handler at B", pe);
-    owl_popexec_unref(pe);
+    owl_select_remove_dispatch(d->fd);
     return;
   }
 
-  if (pe->rfd<0 || !pe->pid || !pe->winactive || rv_navail) {
+  if (d->fd<0 || !pe->pid || !pe->winactive || rv_navail) {
     owl_function_error("popexec should not have reached this point");
     return;
@@ -148,6 +135,6 @@
   if (navail>1024) { navail = 1024; }
   buf = owl_malloc(navail+1);
-  owl_function_debugmsg("about to read %d\n", navail);
-  bread = read(fd, buf, navail);
+  owl_function_debugmsg("about to read %d", navail);
+  bread = read(d->fd, buf, navail);
   if (bread<0) {
     perror("read");
@@ -157,5 +144,5 @@
     buf[navail] = '\0';
   }
-  owl_function_debugmsg("got data:  <%s>\n", buf);
+  owl_function_debugmsg("got data:  <%s>", buf);
   if (pe->winactive) {
     owl_viewwin_append_text(pe->vwin, buf);
@@ -166,4 +153,11 @@
 }
 
+void owl_popexec_free_dispatch(owl_dispatch *d)
+{
+  owl_popexec *pe = d->data;
+  close(d->fd);
+  owl_popexec_unref(pe);
+}
+
 void owl_popexec_viewwin_onclose(owl_viewwin *vwin, void *data)
 {
@@ -172,7 +166,6 @@
 
   pe->winactive = 0;
-  if (pe->rfd>0) {
-    close(pe->rfd);
-    pe->rfd = -1;
+  if (pe->dispatch.fd>0) {
+    owl_select_remove_dispatch(pe->dispatch.fd);
   }
   if (pe->pid) {
Index: popwin.c
===================================================================
--- popwin.c	(revision 818a07348f30d7fbee5ff8c98ceca4886c9a710f)
+++ popwin.c	(revision f34dd65b3adbc2eedc045a674dd89b7e20257680)
@@ -57,14 +57,4 @@
 }
 
-int owl_popwin_display_text(owl_popwin *pw, char *text)
-{
-  waddstr(pw->popwin, text);
-  wnoutrefresh(pw->popwin);
-  touchwin(pw->borderwin);
-  wnoutrefresh(pw->borderwin);
-  owl_global_set_needrefresh(&g);
-  return(0);
-}	      
-
 int owl_popwin_close(owl_popwin *pw)
 {
@@ -96,14 +86,4 @@
 }
 
-void owl_popwin_set_handler(owl_popwin *pw, void (*func)(int ch))
-{
-  pw->handler=func;
-}
-
-void owl_popwin_unset_handler(owl_popwin *pw)
-{
-  pw->handler=NULL;
-}
-
 WINDOW *owl_popwin_get_curswin(owl_popwin *pw)
 {
Index: regex.c
===================================================================
--- regex.c	(revision 8b7466b709fc7f9b93872e1191dfa060187cf2d4)
+++ regex.c	(revision 554a2b836ba40cb8a9fbbc1b1b8aeb195a334e78)
@@ -13,5 +13,5 @@
 {
   int ret;
-  char buff1[LINE], buff2[LINE];
+  char buff1[LINE];
   char *ptr;
   
@@ -29,6 +29,5 @@
   if (ret) {
     regerror(ret, NULL, buff1, LINE);
-    sprintf(buff2, "Error in regular expression: %s", buff1);
-    owl_function_makemsg(buff2);
+    owl_function_makemsg("Error in regular expression: %s", buff1);
     owl_free(re->string);
     re->string=NULL;
